'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = plugin;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _markdownscript = require('markdownscript');

var _markdownscript2 = _interopRequireDefault(_markdownscript);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var h1 = _markdownscript2.default.h1;
var blockquote = _markdownscript2.default.blockquote;
function plugin(mos, markdown) {
  var mdbasename = _path2.default.basename(markdown.filePath);
  if (mdbasename.match(/^readme\./i)) {
    mos.compile.pre(function (next, root, opts) {
      var title = h1([markdown.pkg.name]);
      var firstChild = root.children[0];
      if (firstChild && firstChild.type === 'heading' && firstChild.depth === 1) {
        root.children[0] = title;
      } else {
        root.children.unshift(title);
      }

      if (!(root.children[1] && root.children[1].type === 'markdownScript' && root.children[1].code.match(/\bshields\b/))) {
        root.children.splice(1, 0, (0, _markdownscript2.default)('markdownScript', {
          code: "shields('npm', 'travis')"
        }, []));
      }

      var shortDescr = blockquote([markdown.pkg.description]);
      if (root.children[2] && root.children[2].type === 'blockquote') {
        root.children[2] = shortDescr;
      } else {
        root.children.splice(2, 0, shortDescr);
      }

      return next.applySame();
    });
  }
}

plugin.attributes = {
  pkg: require('./package.json')
};
module.exports = exports['default'];